var styles = " \
#brks_addon_text * {font-family:arial;color:black} \
#brks_addon_text {font-family:arial;position:absolute;background:white;display:none;padding:10px;border-radius:8px; moz-border-radius:8px;font-size:12pt;border:1px solid gray;z-index:9999999;box-shadow: 0 0 5px 5px #999;-moz-box-shadow: 0 0 5px 5px #999;-webkit-box-shadow: 0 0 5px 5px #999;max-width:1000px;} \
#brks_addon_text #word_ch {font-size:17pt;font-family:KaiTi,simsun,Nsimsun,arial unicode MS, sans-serif,arial;} \
#brks_addon_text #word_py {font-size:14pt;} \
#brks_addon_text .m1{margin-left:0.5em} \
#brks_addon_text .m2{margin-left:1em} \
#brks_addon_text .m3{margin-left:1.5em} \
#brks_addon_text .ex {color:#666666} \
#brks_addon_text a {color:darkblue;text-decoration:none} \
#brks_addon_text a:hover {color:#BF9631;text-decoration:none} \
#brks_addon_text a.w_bad {color:#6b6b6b} \
#brks_addon_text a.w_bad:hover {color:black} \
#brks_addon_text a.bkrs_black {color:black} \
#brks_addon_text .ch3 {text-align:center;font-size:18pt;font-family:KaiTi,simsun,Nsimsun,arial unicode MS, sans-serif,arial;} \
#brks_addon_text .vtop {vertical-align:top} \
#brks_addon_text .ch_font {font-family:KaiTi,simsun,Nsimsun,arial unicode MS, sans-serif,arial;} \
#brks_addon_text .too_long {position:absolute;width:247px;padding-bottom:5px;border-bottom:1px solid gray;padding-left:3px} \
#brks_addon_text .td_word_hover {background:#f8f8f8;} \
#brks_addon_text .tbl_bywords {border-collapse:collapse} \
#brks_addon_text .tbl_bywords td {padding:0 3px} \
#brks_addon_text .hidden {display:none} \
#brks_addon_text .gray {color:gray} \
#brks_addon_text .green, #brks_addon_text .green i {color:green} \
#brks_addon_text .pt10 {font-size:10pt} \
#brks_addon_text .pt14 {font-size:14pt} \
#brks_addon_text .pt16 {font-size:16pt} \
#brks_addon_text .pt18 {font-size:18pt} \
";
var bkrs_addon_can_close = 1;
var bkrs_selection = '';
var position_top = 0;

chrome.runtime.onMessage.addListener(function(request, sender, sendResponse) {
	state = request.state;
});

$(document.body).bind('mouseup', function(e) {
	chrome.storage.local.get('state', function (data) {
		if ( typeof data.state === 'undefined' || data.state == 1 ) {

			var text = window.getSelection().toString();

			if ( ! $('#bkrs_styles').length ) {
				$("head").append("<style id='bkrs_styles'>"+styles+"</style>");
			}
			if ( ! $('#brks_addon_text').length ) {
				$('body').append("<div id='brks_addon_text'></div>");
			}

			// check if textarea or input
			if ( text == '' )
			{
				var $focused = $(':focus');
				if ( $focused.is("input") || $focused.is("textarea") )
				{
					var text_data = $focused.getSelection();
					if ( text_data['length'] )
						text = text_data['text'];
				}
			}

			if ( text != '' && text.length < 60 && /[一-鶴]/.test(text) )
			{
				position_top = e.pageY + 40;

				var xhr = new XMLHttpRequest();
				xhr.open("GET", "http://bkrs.info/addon.php?text="+encodeURIComponent(text)+"&version=1.1&browser=chrome", true);
//				xhr.open("GET", "http://localhost/qiaojiao/public_html/bkrs.info/addon.php?text="+encodeURIComponent(text)+"&version=1.1&browser=chrome", true);
				xhr.onreadystatechange = function()
				{
					if (xhr.readyState == 4)
					{
						console.log(xhr)
						data = jQuery.parseJSON(xhr.responseText);

						$('#brks_addon_text').html("<div>"+data.data+"</div>").show();
						if ( bkrs_selection != text )
						{
							$('#brks_addon_text').css({top: e.pageY + 40, left: 20});
						}

						bkrs_addon_can_close = 0;
						var timerId = setTimeout(function() { bkrs_addon_can_close = 1 }, 500);

						bkrs_selection = text;
					}
				}
				xhr.send();
			}
			else
				$('#brks_addon_text').hide();
		} // end storage get callback
	}); // end storage get
});


$('body').mouseup(function()
{
	if ( bkrs_addon_can_close == 1 )
		$('#brks_addon_text').hide();
});


// hover td for byword
$('body').on('mouseenter', '#brks_addon_text td[word]', function() {
	var word = $(this).attr('word');
	$('td[word='+word+']').addClass('td_word_hover');
});
$('body').on('mouseleave', '#brks_addon_text td[word]', function() {
	var word = $(this).attr('word');
	$('td[word='+word+']').removeClass('td_word_hover');
});

// show hidden
$('body').on('mouseenter', '#brks_addon_text .not_full', function() {
	$(this).find('.hidden').slideToggle('fast');
	$(this).find('.link_show').css('visibility', 'hidden');
});
$('body').on('mouseleave', '#brks_addon_text .not_full', function() {
	$(this).find('.hidden').slideToggle('fast');
	$(this).find('.link_show').css('visibility', 'visible');
});